diff --git a/src/backend/utils/misc/sampling.c b/src/backend/utils/misc/sampling.c
index aaf1d6c..5356d29 100644
--- a/src/backend/utils/misc/sampling.c
+++ b/src/backend/utils/misc/sampling.c
@@ -237,7 +237,13 @@ sampler_random_init_state(long seed, SamplerRandomState randstate)
 double
 sampler_random_fract(SamplerRandomState randstate)
 {
-	return pg_erand48(randstate);
+	double res = pg_erand48(randstate);
+
+	/* pg_erand48 returns a value in [0.0 - 1.0) */
+	while (res == 0.0)
+		res = pg_erand48(randstate);
+
+	return res;
 }
 
 
